AJS.$(document).ready(function () {
    AJS.$("#collab-integration").submit(function (event) {
        event.preventDefault();
        saveIntegration();
    });

    AJS.$("#test-connection").click(function (event) {
        event.preventDefault();
        testConnection();
    });
});

var baseUrl = AJS.$("meta[name='ajs-base-url']").attr("content");

function saveIntegration() {
    var collabIntegration = initCollabIntegration();

    if ("valid" != validateIntegration(collabIntegration)) {
        return;
    }

    AJS.$("#submit-integration").prop("disabled", true);

    function success(data) {
        AJS.messages.success({
            body: '<p> Collaborator integration has been saved</p>'
        });
        console.log("Collaborator integration saved");
        AJS.$("#submit-integration").prop("disabled", false);
    }

    function error(e) {
        AJS.messages.error({
            body: '<p> Something went wrong</p>'
        });
        console.log("ERROR : ", e.responseText);
        $("#submit-integration").prop("disabled", false);
    }

    doPost(baseUrl + "/rest/collab/1.0/collab-integration", collabIntegration, "json", success, error);
}

function testConnection() {
    var collabIntegration = initCollabIntegration();

    if ("valid" !== validateIntegration(collabIntegration)) {
        return;
    }

    AJS.$("#test-connection").prop("disabled", true);

    function success() {
        AJS.messages.success({
            body: '<p> Connected successfully</p>'
        });
        AJS.$("#test-connection").prop("disabled", false);
    }

    function error(e) {
        AJS.messages.error({
            body: '<p> ' + e.responseText + '</p>'
        });
        console.log("ERROR : ", e.responseText);
        AJS.$("#test-connection").prop("disabled", false);
    }

    doPost(baseUrl + "/rest/collab/1.0/collab-integration/checking", collabIntegration, "json", success, error);
}

function initCollabIntegration() {
    var admin = {
        login: AJS.$("#login").val(),
        password: window.btoa(AJS.$("#password").val())
    };

    var collabIntegration = {
        collabUrl: AJS.$("#collabUrl").val(),
        projectKey: AJS.$("#projectKey").val(),
        showReviewsToEveryone: AJS.$("#showReviewsToEveryone").is(':checked'),
        user: admin
    };

    return collabIntegration;
}

function validateIntegration(collabIntegration) {
    AJS.$(".aui-message").remove();
    if (!collabIntegration.collabUrl.replace(/\s/g, '')) {
        AJS.messages.error({
            body: '<p> Collaborator URL cannot be empty.</p>'
        });
    } else if (!collabIntegration.user.login.replace(/\s/g, '')) {
        AJS.messages.error({
            body: '<p> Username cannot be empty.</p>'
        });
    } else {
        return "valid";
    }
}

function doPost(url, integration, dataType, success, error) {
    AJS.$.ajax({
        type: "POST",
        contentType: "application/json",
        url: url,
        data: JSON.stringify(integration),
        dataType: dataType,
        cache: false,
        timeout: 600000,
        success: success,
        error: error
    })
}
